'use strict';

exports.__esModule = true;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _reactRedux = require('react-redux');

var _actions = require('./actions');

var _redux = require('redux');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var BsAlert = function (_React$Component) {
    (0, _inherits3['default'])(BsAlert, _React$Component);

    function BsAlert() {
        (0, _classCallCheck3['default'])(this, BsAlert);

        var _this = (0, _possibleConstructorReturn3['default'])(this, _React$Component.call(this));

        _this.handleAlertDismiss = function () {
            _this.props.deleteFlashMessage();
        };

        _this.state = {
            open: false
        };
        return _this;
    }

    BsAlert.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
        this.setState({
            open: nextProps.currentAlert ? true : false,
            type: nextProps.currentAlert ? nextProps.currentAlert.type : this.state.type ? this.state.type : 'success',
            title: nextProps.currentAlert ? nextProps.currentAlert.title : this.state.title,
            text: nextProps.currentAlert ? nextProps.currentAlert.text : this.state.text
        });
    };

    BsAlert.prototype.renderFlash = function renderFlash() {
        if (this.props.flashMessage) {
            return _react2['default'].createElement(
                _reactBootstrap.Alert,
                {
                    bsStyle: this.props.flashMessage.style,
                    onDismiss: this.handleAlertDismiss,
                    className: this.props.opts.className,
                    style: this.props.opts.style },
                _react2['default'].createElement(
                    'strong',
                    null,
                    this.props.flashMessage.title
                ),
                ' ',
                this.props.flashMessage.text
            );
        }
        return _react2['default'].createElement(
            _reactBootstrap.Alert,
            { bsStyle: this.state.style,
                onDismiss: this.handleAlertDismiss,
                className: this.props.opts.className,
                style: this.props.opts.style },
            _react2['default'].createElement(
                'strong',
                null,
                this.state.title
            ),
            ' ',
            this.state.text
        );
    };

    BsAlert.prototype.render = function render() {
        return _react2['default'].createElement(
            _reactBootstrap.Collapse,
            { 'in': this.state.open },
            _react2['default'].createElement(
                'div',
                { style: this.props.opts.location ? this.props.opts.location : {
                        position: 'absolute',
                        left: 0,
                        right: 0
                    } },
                this.renderFlash()
            )
        );
    };

    return BsAlert;
}(_react2['default'].Component);

function mapStateToProps(state, ownProps) {
    return {
        currentAlert: state.currentAlert
    };
}
function mapDispatchToProps(dispatch) {
    return (0, _redux.bindActionCreators)({ deleteAlert: _actions.deleteAlert }, dispatch);
}

var location = {
    position: 'absolute',
    left: 0,
    right: 0
};

exports['default'] = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(BsAlert);
module.exports = exports['default'];